Index: src/edu/ucsb/nceas/metacat/restservice/ResourceHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/restservice/ResourceHandler.java	(revision 6090)
+++ src/edu/ucsb/nceas/metacat/restservice/ResourceHandler.java	(revision 6091)
@@ -77,7 +77,6 @@
 import edu.ucsb.nceas.metacat.dataone.CrudService;
 import edu.ucsb.nceas.metacat.dataone.HealthService;
 import edu.ucsb.nceas.metacat.properties.PropertyService;
-import edu.ucsb.nceas.metacat.service.ObjectFormatService;
 import edu.ucsb.nceas.metacat.service.SessionService;
 import edu.ucsb.nceas.metacat.util.RequestUtil;
 import edu.ucsb.nceas.metacat.util.SystemUtil;
@@ -533,7 +532,7 @@
                             if(params.containsKey("format"))
                             {
                                 String format = params.get("format")[0];
-                                of = ObjectFormatService.getFormat(format);
+                                of = ObjectFormat.convert(format);
                             }
                             if(params.containsKey("time"))
                             {
@@ -570,7 +569,7 @@
                             if(params.containsKey("format"))
                             {
                                 String format = params.get("format")[0];
-                                of = ObjectFormatService.getFormat(format);
+                                of = ObjectFormat.convert(format);
                             }
                             if(params.containsKey("eventtime"))
                             {
@@ -1167,10 +1166,6 @@
         cs.setParamsFromRequest(request);
         AuthToken token = new AuthToken(sessionId);
         OutputStream out = null;
-        String textCSV     = ObjectFormatService.getFormat("text/csv").toString();
-        String textPlain   = ObjectFormatService.getFormat("text/plain").toString();
-        String octetStream = ObjectFormatService.getFormat("application/octet-stream").toString();
-        
         try {
             out = response.getOutputStream();
             response.setStatus(200);
@@ -1188,17 +1183,17 @@
                     SystemMetadata sm = cs.getSystemMetadata(token, id);
                     
                     //set the content type
-                    if(sm.getObjectFormat().toString().trim().equals(textCSV))
+                    if(sm.getObjectFormat().toString().trim().equals(ObjectFormat.TEXT_CSV.toString()))
                     {
                         response.setContentType("text/csv");
                         response.setHeader("Content-Disposition", "inline; filename=" + id.getValue() + ".csv");
                     }
-                    else if(sm.getObjectFormat().toString().trim().equals(textPlain))
+                    else if(sm.getObjectFormat().toString().trim().equals(ObjectFormat.TEXT_PLAIN.toString()))
                     {
                         response.setContentType("text/plain");
                         response.setHeader("Content-Disposition", "inline; filename=" + id.getValue() + ".txt");
                     } 
-                    else if(sm.getObjectFormat().toString().trim().equals(octetStream))
+                    else if(sm.getObjectFormat().toString().trim().equals(ObjectFormat.OCTET_STREAM.toString()))
                     {
                         response.setContentType("application/octet-stream");
                     }
@@ -1295,7 +1290,7 @@
                     }
                     else if(name.equals("objectFormat") && value != null) 
                     {
-                        objectFormat = ObjectFormatService.getFormat(value[0]);
+                        objectFormat = ObjectFormat.convert(value[0]);
                     }
                     else if(name.equals("replicaStatus") && value != null)
                     {
Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 6090)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 6091)
@@ -345,7 +345,7 @@
 			ServiceService.registerService("XMLSchemaService", XMLSchemaService.getInstance());
 			
 			// register the object format service
-      ServiceService.registerService("ObjectFormatService", ObjectFormatService.getInstance());
+      //ServiceService.registerService("ObjectFormatService", ObjectFormatService.getInstance());
 
 			// check if eml201 document were corrected or not. if not, correct eml201 documents.
 			// Before Metacat 1.8.1, metacat uses tag RELEASE_EML_2_0_1_UPDATE_6 as eml
Index: src/edu/ucsb/nceas/metacat/MetacatHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6090)
+++ src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6091)
@@ -1,4 +1,4 @@
-/**ml
+/**
  *  '$RCSfile$'
  *  Copyright: 2010 Regents of the University of California and the
  *             National Center for Ecological Analysis and Synthesis
@@ -42,7 +42,6 @@
 import edu.ucsb.nceas.metacat.event.MetacatEventService;
 import edu.ucsb.nceas.metacat.properties.PropertyService;
 import edu.ucsb.nceas.metacat.replication.ForceReplicationHandler;
-import edu.ucsb.nceas.metacat.service.ObjectFormatService;
 import edu.ucsb.nceas.metacat.service.SessionService;
 import edu.ucsb.nceas.metacat.service.XMLSchemaService;
 import edu.ucsb.nceas.metacat.shared.HandlerException;
@@ -3631,12 +3630,12 @@
       
       //set the default object format
       String doctype = (String) docInfo.get("doctype");
-      ObjectFormat format = ObjectFormatService.getFormat(doctype);
+      ObjectFormat format = ObjectFormat.convert(doctype);
       if (format == null) {
           if (doctype.trim().equals("BIN")) {
-              format = ObjectFormatService.getFormat("application/octet-stream");
+              format = ObjectFormat.OCTET_STREAM;
           } else {
-              format = ObjectFormatService.getFormat("text/plain");
+              format = ObjectFormat.convert("text/plain");
           }
       }
       sysMeta.setObjectFormat(format);
@@ -3645,9 +3644,9 @@
       
       // further parse EML documents to get data object format,
       // describes and describedBy information
-      if ( format == ObjectFormatService.getFormat("eml://ecoinformatics.org/eml/2.0.0") ||
-           format == ObjectFormatService.getFormat("eml://ecoinformatics.org/eml/2.0.1") ||
-           format == ObjectFormatService.getFormat("eml://ecoinformatics.org/eml/2.1.0")) {
+      if ( format == ObjectFormat.EML_2_0_0 ||
+           format == ObjectFormat.EML_2_0_1 ||
+           format == ObjectFormat.EML_2_1_0 ) {
         
         try {
           DataoneEMLParser emlParser = DataoneEMLParser.getInstance();
@@ -3664,16 +3663,10 @@
               emlDocument.distributionMetadata.elementAt(j);
             String dataDocUrl = distMetadata.url;
             String dataDocMimeType = "";
-            
             if (distMetadata.mimeType == null) {
-                
-              dataDocMimeType = 
-                  ObjectFormatService.getFormat("application/octet-stream").toString();
-            
+                dataDocMimeType = ObjectFormat.OCTET_STREAM.name();
             } else {
-                
-              dataDocMimeType = distMetadata.mimeType;
-              
+                dataDocMimeType = distMetadata.mimeType;
             }
             String dataDocLocalId = "";
             String dataSysMetaId = "";
@@ -3704,9 +3697,9 @@
                 logMetacat.debug("Setting describedBy for " + dataDocId.getValue() +
                                  " to " + identifier.getValue());
                 dataSysMeta.addDescribedBy(identifier);
-                ObjectFormat f = ObjectFormatService.getFormat(dataDocMimeType);
+                ObjectFormat f = ObjectFormat.convert(dataDocMimeType);
                 if (f == null) {
-                    f = ObjectFormatService.getFormat("application/octet-stream");
+                    f = ObjectFormat.OCTET_STREAM;
                 }
                 dataSysMeta.setObjectFormat(f);
                 dataSysMetaId = insertOrUpdateSystemMetadata(
@@ -3728,11 +3721,9 @@
                   
                   logMetacat.debug("Setting mimeType for " + 
                     dataDocId.getValue() + " to " + dataDocMimeType);
-                  
-                  ObjectFormat f = ObjectFormatService.getFormat(dataDocMimeType);
-                  
+                  ObjectFormat f = ObjectFormat.convert(dataDocMimeType);
                   if (f == null) {
-                      f = ObjectFormatService.getFormat("application/octet-stream");
+                      f = ObjectFormat.OCTET_STREAM;
                   }
                   dataSysMeta.setObjectFormat(f);
                   
Index: src/edu/ucsb/nceas/metacat/service/ObjectFormatService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/ObjectFormatService.java	(revision 6090)
+++ src/edu/ucsb/nceas/metacat/service/ObjectFormatService.java	(revision 6091)
@@ -55,7 +55,7 @@
 import org.dataone.service.exceptions.ServiceFailure;
 import org.dataone.service.types.Identifier;
 import org.dataone.service.types.ObjectFormat;
-import org.dataone.service.types.ObjectFormatList;
+//import org.dataone.service.types.ObjectFormatList;
 import org.dataone.service.types.util.ServiceTypeUtil;
 import org.jibx.runtime.JiBXException;
 
@@ -87,7 +87,7 @@
   private String accNumber = null;
 
   /* The list of object formats */
-  private static ObjectFormatList objectFormatList = null;
+  //private static ObjectFormatList objectFormatList = null;
   
   /* the searchable map of object formats */
   private static HashMap<String, ObjectFormat> objectFormatMap = 
@@ -229,12 +229,12 @@
        */
       
       // this will be replaced with external lookup code above
-      this.getCachedList();
+      //this.getCachedList();
       
     } else if ( this.nodeType.equals("cn") ) {
       
       // get the list from the local metacat database
-      this.getCachedList();  
+      //this.getCachedList();  
 
     } else {
       
@@ -245,16 +245,16 @@
     }
     
     // index the object format list based on the format identifier
-    int listSize = ObjectFormatService.objectFormatList.sizeObjectFormats();
-    
-    for (int i = 0; i < listSize; i++ ) {
-      
-      ObjectFormat objectFormat = 
-        ObjectFormatService.objectFormatList.getObjectFormat(i);
-      String identifier = objectFormat.getFmtid();
-      ObjectFormatService.objectFormatMap.put(identifier, objectFormat);
-      
-    }
+    //int listSize = ObjectFormatService.objectFormatList.sizeObjectFormats();
+    //
+    //for (int i = 0; i < listSize; i++ ) {
+    //  
+    //  ObjectFormat objectFormat = 
+    //    ObjectFormatService.objectFormatList.getObjectFormat(i);
+    //  String identifier = objectFormat.getFmtid();
+    //  ObjectFormatService.objectFormatMap.put(identifier, objectFormat);
+    //  
+    //}
         
 
     
@@ -287,11 +287,11 @@
    * 
    * @return objectFormatList - the list of object formats
    */
-  public ObjectFormatList listFormats() {
-    
-    return ObjectFormatService.objectFormatList;
-    
-  }
+  //public ObjectFormatList listFormats() {
+  //  
+  //  return ObjectFormatService.objectFormatList;
+  //  
+  //}
   
   /**
    * Get the object format based on the given identifier as a string.
@@ -299,14 +299,14 @@
    * @param format - the object format as a string
    * @return objectFormat - the ObjectFormat represented by the format string
    */
-  public static ObjectFormat getFormat(String format) {
-    
-    ObjectFormat objectFormat = null;
-    objectFormat = ObjectFormatService.objectFormatMap.get(format);
-    
-    return objectFormat;
-    
-  }
+  //public static ObjectFormat getFormat(String format) {
+  //  
+  //  ObjectFormat objectFormat = null;
+  //  objectFormat = ObjectFormatService.objectFormatMap.get(format);
+  //  
+  //  return objectFormat;
+  //  
+  //}
   /**
    * Get the object format list cached in Metacat, or on failure, via a
    * cached file on disk
@@ -313,98 +313,98 @@
    * 
    * @return objectFormatList - the cached object format list
    */
-  private void getCachedList()
-    throws ServiceException {
-          
-    try {
-      
-      // reset the accession number separator in case it is 
-      // different than the default
-      try {
-        
-        this.separator = PropertyService.getProperty("document.accNumSeparator");
-        
-      } catch ( PropertyNotFoundException pnfe ) {
-        
-        // use the default separator, but log the issue
-        logMetacat.debug("There was a problem finding the document " +
-          "separator property. The error message was: " + pnfe.getMessage());
-      }
-      
-      // get the latest accession number if it is in Metacat
-      this.rev = 
-        DBUtil.getLatestRevisionInDocumentTable(this.OBJECT_FORMAT_DOCID);
-      
-      if ( this.rev != -1 ) {
-        this.accNumber = this.OBJECT_FORMAT_DOCID + 
-                         this.separator + 
-                         this.rev;
-        DocumentImpl objectFormatsDocument = new DocumentImpl(accNumber, false);
-        ByteArrayInputStream bais = 
-          new ByteArrayInputStream(objectFormatsDocument.toString().getBytes());
-        ObjectFormatService.objectFormatList = 
-          this.deserializeObjectFormatList(bais);
+  //private void getCachedList()
+  //  throws ServiceException {
+  //        
+  //  try {
+  //    
+  //    // reset the accession number separator in case it is 
+  //    // different than the default
+  //    try {
+  //      
+  //      this.separator = PropertyService.getProperty("document.accNumSeparator");
+  //      
+  //    } catch ( PropertyNotFoundException pnfe ) {
+  //      
+  //      // use the default separator, but log the issue
+  //      logMetacat.debug("There was a problem finding the document " +
+  //        "separator property. The error message was: " + pnfe.getMessage());
+  //    }
+  //    
+  //    // get the latest accession number if it is in Metacat
+  //    this.rev = 
+  //      DBUtil.getLatestRevisionInDocumentTable(this.OBJECT_FORMAT_DOCID);
+  //    
+  //    if ( this.rev != -1 ) {
+  //      this.accNumber = this.OBJECT_FORMAT_DOCID + 
+  //                       this.separator + 
+  //                       this.rev;
+  //      DocumentImpl objectFormatsDocument = new DocumentImpl(accNumber, false);
+  //      ByteArrayInputStream bais = 
+  //        new ByteArrayInputStream(objectFormatsDocument.toString().getBytes());
+  //      ObjectFormatService.objectFormatList = 
+  //        this.deserializeObjectFormatList(bais);
+  //
+  //    } else {
+  //      
+  //      logMetacat.info("The latest revision number of "   + 
+  //        this.OBJECT_FORMAT_DOCID                         +
+  //        " could not be found. Reverting to the on-disk " +
+  //        "object format list");
+  //      try {
+  //        
+  //        ObjectFormatService.objectFormatList = this.getListFromDisk();
+  //      
+  //      } catch (ServiceException se) {
+  //        
+  //        throw new ServiceException(se.getMessage());
+  //      
+  //      }
+  //
+  //    }
+  //    
+  //  } catch ( SQLException sqle ) {
+  //    
+  //    // we either have a metacat error or the docid was not inserted yet
+  //    logMetacat.info("The latest revision number of "   + 
+  //      this.OBJECT_FORMAT_DOCID                         +
+  //      " could not be found. Reverting to the on-disk " +
+  //      "object format list");
+  //    
+  //    try {
+  //      
+  //      ObjectFormatService.objectFormatList = this.getListFromDisk();
+  //    
+  //    } catch (ServiceException se) {
+  //      
+  //      throw se; 
+  //      
+  //    }
+  //    
+  //  } catch (McdbException mcdbe) {
+  //    
+  //    // we have a metacat doc not found error
+  //    logMetacat.info( this.OBJECT_FORMAT_DOCID          +
+  //      " could not be found. Reverting to the on-disk " +
+  //      "object format list");
+  //    
+  //    try {
+  //      
+  //      ObjectFormatService.objectFormatList = this.getListFromDisk();
+  //    
+  //    } catch (ServiceException se) {
+  //      
+  //      throw se; 
+  //      
+  //    }
+  //    
+  //
+  //  }
+  //
+  //  return;
+  //  
+  //}
 
-      } else {
-        
-        logMetacat.info("The latest revision number of "   + 
-          this.OBJECT_FORMAT_DOCID                         +
-          " could not be found. Reverting to the on-disk " +
-          "object format list");
-        try {
-          
-          ObjectFormatService.objectFormatList = this.getListFromDisk();
-        
-        } catch (ServiceException se) {
-          
-          throw new ServiceException(se.getMessage());
-        
-        }
-  
-      }
-      
-    } catch ( SQLException sqle ) {
-      
-      // we either have a metacat error or the docid was not inserted yet
-      logMetacat.info("The latest revision number of "   + 
-        this.OBJECT_FORMAT_DOCID                         +
-        " could not be found. Reverting to the on-disk " +
-        "object format list");
-      
-      try {
-        
-        ObjectFormatService.objectFormatList = this.getListFromDisk();
-      
-      } catch (ServiceException se) {
-        
-        throw se; 
-        
-      }
-      
-    } catch (McdbException mcdbe) {
-      
-      // we have a metacat doc not found error
-      logMetacat.info( this.OBJECT_FORMAT_DOCID          +
-        " could not be found. Reverting to the on-disk " +
-        "object format list");
-      
-      try {
-        
-        ObjectFormatService.objectFormatList = this.getListFromDisk();
-      
-      } catch (ServiceException se) {
-        
-        throw se; 
-        
-      }
-      
-
-    }
-
-    return;
-    
-  }
-
   /**
    * Get the object format list cached on disk as stated in the metacat
    * properties file.
@@ -412,40 +412,40 @@
    * @return objectFormatList - the on-disk object format list
    * @throws ServiceException
    */
-  private ObjectFormatList getListFromDisk() 
-    throws ServiceException {
-    
-    // the filesystem location of the object format list xml file
-    String objectFormatFilePath = null;
-    
-    // get the object format list from disk and parse it
-    try {
-      objectFormatFilePath = SystemUtil.getContextDir() + "/WEB-INF/" +
-        PropertyService.getProperty("dataone.objectFormatListName");
-            
-      FileInputStream fileInputStream = new FileInputStream(objectFormatFilePath);         
+  //private ObjectFormatList getListFromDisk() 
+  //  throws ServiceException {
+  //  
+  //  // the filesystem location of the object format list xml file
+  //  String objectFormatFilePath = null;
+  //  
+  //  // get the object format list from disk and parse it
+  //  try {
+  //    objectFormatFilePath = SystemUtil.getContextDir() + "/WEB-INF/" +
+  //      PropertyService.getProperty("dataone.objectFormatListName");
+  //          
+  //    FileInputStream fileInputStream = new FileInputStream(objectFormatFilePath);         
+  //
+  //    ObjectFormatService.objectFormatList = 
+  //      this.deserializeObjectFormatList(fileInputStream);
+  //
+  //  } catch (PropertyNotFoundException pnfe) {
+  //    
+  //    logMetacat.error("The object format list file could not be parsed. " +
+  //      "The error message was: " + pnfe.getMessage());
+  //    throw new ServiceException(pnfe.getMessage());
+  //    
+  //  } catch ( FileNotFoundException fnfe ) {
+  //    
+  //    logMetacat.debug("There was an error reading the file " +
+  //      objectFormatFilePath + ". The error was: "            +
+  //      fnfe.getMessage());
+  //    throw new ServiceException(fnfe.getMessage());
+  //        
+  //  }
+  //  
+  //  return ObjectFormatService.objectFormatList;
+  //}
 
-      ObjectFormatService.objectFormatList = 
-        this.deserializeObjectFormatList(fileInputStream);
-
-    } catch (PropertyNotFoundException pnfe) {
-      
-      logMetacat.error("The object format list file could not be parsed. " +
-        "The error message was: " + pnfe.getMessage());
-      throw new ServiceException(pnfe.getMessage());
-      
-    } catch ( FileNotFoundException fnfe ) {
-      
-      logMetacat.debug("There was an error reading the file " +
-        objectFormatFilePath + ". The error was: "            +
-        fnfe.getMessage());
-      throw new ServiceException(fnfe.getMessage());
-          
-    }
-    
-    return ObjectFormatService.objectFormatList;
-  }
-
   /**
    * Deserialize the object format list file to an object format list object
    * 
@@ -453,23 +453,23 @@
    * @return objectFormatList - the ObjectFormatList object from the XML stream
    * @throws ServiceException
    */
-  private ObjectFormatList deserializeObjectFormatList(InputStream inputStream) 
-    throws ServiceException {
-    
-    ObjectFormatList objectFormatList;
-    try {
-      objectFormatList = (ObjectFormatList)
-      ServiceTypeUtil.deserializeServiceType(ObjectFormatList.class, inputStream);
-    
-    } catch ( JiBXException jbxe ) {
-      
-      logMetacat.debug("There was an error deserializing the input stream. " +
-        "The error was: " + jbxe.getMessage());
-      jbxe.printStackTrace();
-      throw new ServiceException(jbxe.getMessage());
-    }
-    
-    return objectFormatList;
-  }
+  //private ObjectFormatList deserializeObjectFormatList(InputStream inputStream) 
+  //  throws ServiceException {
+  //  
+  //  ObjectFormatList objectFormatList;
+  //  try {
+  //    objectFormatList = (ObjectFormatList)
+  //    ServiceTypeUtil.deserializeServiceType(ObjectFormatList.class, inputStream);
+  //  
+  //  } catch ( JiBXException jbxe ) {
+  //    
+  //    logMetacat.debug("There was an error deserializing the input stream. " +
+  //      "The error was: " + jbxe.getMessage());
+  //    jbxe.printStackTrace();
+  //    throw new ServiceException(jbxe.getMessage());
+  //  }
+  //  
+  //  return objectFormatList;
+  //}
   
 }
\ No newline at end of file
Index: src/edu/ucsb/nceas/metacat/util/MetacatPopulator.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/MetacatPopulator.java	(revision 6090)
+++ src/edu/ucsb/nceas/metacat/util/MetacatPopulator.java	(revision 6091)
@@ -48,7 +48,6 @@
 import edu.ucsb.nceas.metacat.dataone.CrudService;
 import edu.ucsb.nceas.metacat.properties.PropertyService;
 import edu.ucsb.nceas.metacat.restservice.InputStreamDataSource;
-import edu.ucsb.nceas.metacat.service.ObjectFormatService;
 
 import org.dataone.service.exceptions.InvalidSystemMetadata;
 import org.dataone.service.exceptions.ServiceFailure;
@@ -191,7 +190,7 @@
                     SystemMetadata dataDocSysMeta = generateSystemMetadata(doc);
                     //overwrite the bogus values from the last call 
                     dataDocSysMeta.setIdentifier(did);
-                    dataDocSysMeta.setObjectFormat(ObjectFormatService.getFormat(dataDocMimeType));
+                    dataDocSysMeta.setObjectFormat(ObjectFormat.convert(dataDocMimeType));
                     Checksum checksum = new Checksum();
                     dataDocIs = stringToStream(dataDocText);
                     ChecksumAlgorithm ca = ChecksumAlgorithm.convert("MD5");
@@ -283,16 +282,16 @@
         sm.setIdentifier(id);
         
         //set the object format
-        ObjectFormat format = ObjectFormatService.getFormat(doc.doctype);
+        ObjectFormat format = ObjectFormat.convert(doc.doctype);
         if(format == null)
         {
             if(doc.doctype.trim().equals("BIN"))
             {
-                format = ObjectFormatService.getFormat("application/octet-stream");
+                format = ObjectFormat.OCTET_STREAM;
             }
             else
             {
-                format = ObjectFormatService.getFormat("text/plain");
+                format = ObjectFormat.TEXT_PLAIN;
             }
         }
         sm.setObjectFormat(format);
Index: src/edu/ucsb/nceas/metacat/dataone/CrudService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/dataone/CrudService.java	(revision 6090)
+++ src/edu/ucsb/nceas/metacat/dataone/CrudService.java	(revision 6091)
@@ -109,7 +109,6 @@
 import edu.ucsb.nceas.metacat.properties.PropertyService;
 import edu.ucsb.nceas.metacat.replication.ForceReplicationHandler;
 import edu.ucsb.nceas.metacat.service.SessionService;
-import edu.ucsb.nceas.metacat.service.ObjectFormatService;
 import edu.ucsb.nceas.metacat.util.DocumentUtil;
 import edu.ucsb.nceas.metacat.util.SessionData;
 
@@ -2070,12 +2069,12 @@
 
     	//set the default object format
     	String doctype = (String) docInfo.get("doctype");
-    	ObjectFormat format = ObjectFormatService.getFormat(doctype);
+    	ObjectFormat format = ObjectFormat.convert(doctype);
     	if (format == null) {
     		if (doctype.trim().equals("BIN")) {
-    			format = ObjectFormatService.getFormat("application/octet-stream");
+    			format = ObjectFormat.OCTET_STREAM;
     		} else {
-    			format = ObjectFormatService.getFormat("text/plain");
+    			format = ObjectFormat.convert("text/plain");
     		}
     	}
     	sm.setObjectFormat(format);
@@ -2083,9 +2082,9 @@
 
     	// further parse EML documents to get data object format,
     	// describes and describedBy information
-    	if ( format == ObjectFormatService.getFormat("eml://ecoinformatics.org/eml/2.0.0") ||
-    			format == ObjectFormatService.getFormat("eml://ecoinformatics.org/eml/2.0.1") ||
-    			format == ObjectFormatService.getFormat("eml://ecoinformatics.org/eml/2.1.0") ) {
+    	if ( format == ObjectFormat.EML_2_0_0 ||
+    			format == ObjectFormat.EML_2_0_1 ||
+    			format == ObjectFormat.EML_2_1_0 ) {
 
     		try {
     			DataoneEMLParser emlParser = DataoneEMLParser.getInstance();
@@ -2128,7 +2127,7 @@
     						logCrud.debug("Setting describedBy for " + dataDocId.getValue() +
     								" to " + identifier.getValue());
     						dataSysMeta.addDescribedBy(identifier);
-    						dataSysMeta.setObjectFormat(ObjectFormatService.getFormat(dataDocMimeType));
+    						dataSysMeta.setObjectFormat(ObjectFormat.convert(dataDocMimeType));
     						this.updateSystemMetadata(dataSysMeta, getSessionData(token));
 
     					} catch ( NotFound nf ) {
@@ -2141,7 +2140,7 @@
     						dataSysMeta.addDescribedBy(identifier);
 
     						logCrud.debug("Setting mimeType for " + dataDocId.getValue() + " to " + dataDocMimeType);
-    						dataSysMeta.setObjectFormat(ObjectFormatService.getFormat(dataDocMimeType));
+    						dataSysMeta.setObjectFormat(ObjectFormat.convert(dataDocMimeType));
 
     						logCrud.debug("Updating system metadata for " + dataDocId.getValue() + " to " + dataDocMimeType);
     						this.updateSystemMetadata(dataSysMeta, getSessionData(token));
Index: src/edu/ucsb/nceas/metacat/IdentifierManager.java
===================================================================
--- src/edu/ucsb/nceas/metacat/IdentifierManager.java	(revision 6090)
+++ src/edu/ucsb/nceas/metacat/IdentifierManager.java	(revision 6091)
@@ -43,7 +43,6 @@
 import edu.ucsb.nceas.metacat.database.DBConnection;
 import edu.ucsb.nceas.metacat.database.DBConnectionPool;
 import edu.ucsb.nceas.metacat.properties.PropertyService;
-import edu.ucsb.nceas.metacat.service.ObjectFormatService;
 import edu.ucsb.nceas.metacat.shared.ServiceException;
 import edu.ucsb.nceas.metacat.util.DocumentUtil;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
@@ -1002,7 +1001,7 @@
                 //cs.setAlgorithm(ChecksumAlgorithm.convert(checksumAlgorithm));
                 oi.setChecksum(cs);
                 
-                ObjectFormat oFormat = ObjectFormatService.getFormat(format);
+                ObjectFormat oFormat = ObjectFormat.convert(format);
                 if(oFormat != null)
                 {
                     oi.setObjectFormat(oFormat);
@@ -1009,7 +1008,7 @@
                 }
                 else
                 { //if there is no object format, just default to text/plain
-                    oi.setObjectFormat(ObjectFormatService.getFormat("application/octet-stream"));
+                    oi.setObjectFormat(ObjectFormat.OCTET_STREAM);
                 }
                                 
                 oi.setSize(size);