Index: lib/d1_common_java-0.6.0.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: lib/d1_common_java-0.6.0.jar
___________________________________________________________________
Deleted: svn:mime-type
## -1 +0,0 ##
-application/octet-stream
\ No newline at end of property
Index: lib/d1_common_java-0.5.0.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: lib/d1_common_java-0.5.0.jar
___________________________________________________________________
Deleted: svn:mime-type
## -1 +0,0 ##
-application/octet-stream
\ No newline at end of property
Index: lib/d1_libclient_java-0.5.2.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: lib/d1_libclient_java-0.5.2.jar
___________________________________________________________________
Deleted: svn:mime-type
## -1 +0,0 ##
-application/octet-stream
\ No newline at end of property
Index: test/edu/ucsb/nceas/metacat/dataone/CrudServiceTest.java
===================================================================
--- test/edu/ucsb/nceas/metacat/dataone/CrudServiceTest.java	(revision 6091)
+++ test/edu/ucsb/nceas/metacat/dataone/CrudServiceTest.java	(revision 6092)
@@ -35,7 +35,6 @@
 
 import org.apache.commons.io.IOUtils;
 import org.dataone.service.exceptions.BaseException;
-import org.dataone.service.exceptions.NotFound;
 import org.dataone.service.types.AuthToken;
 import org.dataone.service.types.Checksum;
 import org.dataone.service.types.ChecksumAlgorithm;
@@ -47,7 +46,7 @@
 import org.dataone.service.types.ObjectFormat;
 import org.dataone.service.types.ObjectInfo;
 import org.dataone.service.types.ObjectList;
-import org.dataone.service.types.Principal;
+import org.dataone.service.types.Subject;
 import org.dataone.service.types.SystemMetadata;
 
 import edu.ucsb.nceas.MCTestCase;
@@ -921,7 +920,7 @@
         //set the size
         sm.setSize(testDoc.getBytes(MetaCatServlet.DEFAULT_ENCODING).length);
         //submitter
-        Principal p = new Principal();
+        Subject p = new Subject();
         p.setValue("joe");
         sm.setSubmitter(p);
         sm.setRightsHolder(p);
Index: lib/d1_common_java-0.6.1-SNAPSHOT.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: lib/d1_common_java-0.6.1-SNAPSHOT.jar
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: lib/d1_libclient_java-0.6.1-SNAPSHOT.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: lib/d1_libclient_java-0.6.1-SNAPSHOT.jar
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: src/upgrade-db-to-1.10.0-postgres.sql
===================================================================
--- src/upgrade-db-to-1.10.0-postgres.sql	(revision 6091)
+++ src/upgrade-db-to-1.10.0-postgres.sql	(revision 6092)
@@ -36,8 +36,12 @@
  
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('Schema', 'http://dataone.org/service/types/0.5.1', '/schema/D1_SCHEMA_0_5_1/dataoneTypes.xsd');
-
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.1', '/schema/D1_SCHEMA_0_6_1/dataoneTypes.xsd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.2', '/schema/D1_SCHEMA_0_6_2/dataoneTypes.xsd');
+  
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('Schema', '@eml2_1_1namespace@', '/schema/eml-2.1.1/eml.xsd');  
 /*
  * update the database version
Index: src/loaddtdschema-postgres.sql
===================================================================
--- src/loaddtdschema-postgres.sql	(revision 6091)
+++ src/loaddtdschema-postgres.sql	(revision 6092)
@@ -55,5 +55,9 @@
   VALUES ('Schema', 'http://dataone.org/service/types/0.5.1', '/schema/D1_SCHEMA_0_5_1/dataoneTypes.xsd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.0', '/schema/D1_SCHEMA_0_6_0/dataoneTypes.xsd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.1', '/schema/D1_SCHEMA_0_6_1/dataoneTypes.xsd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.2', '/schema/D1_SCHEMA_0_6_2/dataoneTypes.xsd');
 INSERT INTO db_version (version, status, date_created) 
   VALUES ('1.10.0',1,CURRENT_DATE);
Index: src/upgrade-db-to-1.10.0-oracle.sql
===================================================================
--- src/upgrade-db-to-1.10.0-oracle.sql	(revision 6091)
+++ src/upgrade-db-to-1.10.0-oracle.sql	(revision 6092)
@@ -35,8 +35,12 @@
  */
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('Schema', 'http://dataone.org/service/types/0.5.1', '/schema/D1_SCHEMA_0_5_1/dataoneTypes.xsd');
-
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.1', '/schema/D1_SCHEMA_0_6_1/dataoneTypes.xsd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.2', '/schema/D1_SCHEMA_0_6_2/dataoneTypes.xsd');
+  
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('Schema', '@eml2_1_1namespace@', '/schema/eml-2.1.1/eml.xsd');
 
 /*
Index: src/edu/ucsb/nceas/metacat/MetacatHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6091)
+++ src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6092)
@@ -138,7 +138,7 @@
 import org.dataone.service.types.ChecksumAlgorithm;
 import org.dataone.service.types.Identifier;
 import org.dataone.service.types.ObjectFormat;
-import org.dataone.service.types.Principal;
+import org.dataone.service.types.Subject;
 import org.dataone.service.types.SystemMetadata;
 
 import org.dataone.service.exceptions.BaseException;
@@ -3807,10 +3807,10 @@
       sysMeta.setSize(sizeOfStream(inputStream));
       
       //submitter
-      Principal principal = new Principal();
-      principal.setValue((String) docInfo.get("user_owner"));
-      sysMeta.setSubmitter(principal);
-      sysMeta.setRightsHolder(principal);
+      Subject subject = new Subject();
+      subject.setValue((String) docInfo.get("user_owner"));
+      sysMeta.setSubmitter(subject);
+      sysMeta.setRightsHolder(subject);
 
       try {
         SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-DD");
Index: src/edu/ucsb/nceas/metacat/util/MetacatPopulator.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/MetacatPopulator.java	(revision 6091)
+++ src/edu/ucsb/nceas/metacat/util/MetacatPopulator.java	(revision 6092)
@@ -25,50 +25,40 @@
  */
 package edu.ucsb.nceas.metacat.util;
 
+import java.io.ByteArrayInputStream;
+import java.io.InputStream;
+import java.io.OutputStream;
+import java.net.HttpURLConnection;
+import java.net.URL;
 import java.security.MessageDigest;
-import java.util.*;
-import java.io.*;
-import java.net.*;
+import java.util.Calendar;
+import java.util.Date;
+import java.util.Vector;
 
 import javax.activation.DataHandler;
 import javax.activation.DataSource;
-import javax.mail.MessagingException;
 import javax.mail.internet.MimeBodyPart;
 import javax.mail.internet.MimeMultipart;
-import javax.xml.parsers.DocumentBuilder;
-import javax.xml.parsers.DocumentBuilderFactory;
-import javax.xml.parsers.ParserConfigurationException;
 
 import org.apache.commons.io.IOUtils;
-
-import edu.ucsb.nceas.metacat.MetaCatServlet;
-import edu.ucsb.nceas.metacat.MetacatHandler;
-import edu.ucsb.nceas.metacat.MetacatResultSet;
-import edu.ucsb.nceas.metacat.MetacatResultSet.Document;
-import edu.ucsb.nceas.metacat.dataone.CrudService;
-import edu.ucsb.nceas.metacat.properties.PropertyService;
-import edu.ucsb.nceas.metacat.restservice.InputStreamDataSource;
-
-import org.dataone.service.exceptions.InvalidSystemMetadata;
-import org.dataone.service.exceptions.ServiceFailure;
+import org.dataone.client.D1Client;
+import org.dataone.client.MNode;
+import org.dataone.eml.DataoneEMLParser;
+import org.dataone.eml.EMLDocument;
+import org.dataone.eml.EMLDocument.DistributionMetadata;
 import org.dataone.service.types.AuthToken;
 import org.dataone.service.types.Checksum;
 import org.dataone.service.types.ChecksumAlgorithm;
+import org.dataone.service.types.Identifier;
 import org.dataone.service.types.NodeReference;
 import org.dataone.service.types.ObjectFormat;
-import org.dataone.service.types.Principal;
+import org.dataone.service.types.Subject;
 import org.dataone.service.types.SystemMetadata;
-import org.dataone.service.types.Identifier;
-import org.dataone.client.D1Client;
-import org.dataone.client.MNode;
-import org.dataone.eml.DataoneEMLParser;
-import org.dataone.eml.EMLDocument;
-import org.dataone.eml.EMLDocument.DistributionMetadata;
 
-//import sun.tools.jstat.Identifier;
+import edu.ucsb.nceas.metacat.MetaCatServlet;
+import edu.ucsb.nceas.metacat.properties.PropertyService;
+import edu.ucsb.nceas.metacat.restservice.InputStreamDataSource;
 
-import com.gc.iotools.stream.is.InputStreamFromOutputStream;
-
 /**
  * @author berkley
  * A class to populate a metacat instance based on documents returned from a query
@@ -309,7 +299,7 @@
         sm.setSize(doc.doctext.getBytes(MetaCatServlet.DEFAULT_ENCODING).length);
         
         //submitter
-        Principal p = new Principal();
+        Subject p = new Subject();
         p.setValue("unknown");
         sm.setSubmitter(p);
         sm.setRightsHolder(p);
Index: src/edu/ucsb/nceas/metacat/dataone/CrudService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/dataone/CrudService.java	(revision 6091)
+++ src/edu/ucsb/nceas/metacat/dataone/CrudService.java	(revision 6092)
@@ -84,7 +84,7 @@
 import org.dataone.service.types.NodeReference;
 import org.dataone.service.types.ObjectFormat;
 import org.dataone.service.types.ObjectList;
-import org.dataone.service.types.Principal;
+import org.dataone.service.types.Subject;
 import org.dataone.service.types.SystemMetadata;
 import org.dataone.service.types.util.ServiceTypeUtil;
 
@@ -1292,9 +1292,9 @@
             NodeReference memberNode = new NodeReference();
             memberNode.setValue(ipAddress);
             le.setMemberNode(memberNode);
-            Principal princ = new Principal();
+            Subject princ = new Subject();
             princ.setValue(principal);
-            le.setPrincipal(princ);
+            le.setSubject(princ);
             le.setUserAgent("metacat/RESTService");
             
             if(event == null)
@@ -2177,7 +2177,7 @@
     	sm.setSize(sizeOfStream(is));
 
     	//submitter
-    	Principal p = new Principal();
+    	Subject p = new Subject();
     	p.setValue((String) docInfo.get("user_owner"));
     	sm.setSubmitter(p);
     	sm.setRightsHolder(p);
Index: build.xml
===================================================================
--- build.xml	(revision 6091)
+++ build.xml	(revision 6092)
@@ -185,7 +185,7 @@
 		<property name="eml2_0_1-schema-tag" value="RELEASE_EML_2_0_1" />
 		<property name="eml2_1_0-schema-tag" value="RELEASE_EML_2_1_0" />
 		<property name="eml2_1_1-schema-tag" value="RELEASE_EML_2_1_1_RC_2" />
-		<property name="dataone-schema-tag" value="D1_SCHEMA_0_5_1" />
+		<property name="dataone-schema-tag" value="D1_SCHEMA_0_6_1" />
 		<property name="eml2-style-tag" value="RELEASE_EML_UTILS_1_0_0_RC12" />
 		<property name="eml2_0_0namespace"
 			value="eml://ecoinformatics.org/eml-2.0.0" />
@@ -342,7 +342,7 @@
 		<property name="svn.eml211SchemaUrl"
 			value="https://code.ecoinformatics.org/code/eml/tags/${eml2_1_1-schema-tag}" />
 		<property name="svn.dataone-0.1-schema-url"
-			value="https://repository.dataone.org/software/cicore/tags/${dataone-schema-tag}" />
+			value="https://repository.dataone.org/software/cicore/branches/${dataone-schema-tag}" />
 		<property name="svn.eml2StyleUrl"
 			value="https://code.ecoinformatics.org/code/eml/tags/${eml2-style-tag}" />
 